cf 1163D Mysterious Code (字符串, dp)

大意: 给定字符串$C$, 只含小写字母和‘*‘, ‘*‘表示可以替换为任意小写字母, 再给定字符串$S,T$, 求$S$在$C$中出现次数-$T$在$C$中出现次数最大值.

设$dp[i][j][k]$表示$C$的前$i$位, $S$和$T$分别匹配到第$j$位和第$k$位的最优解

可以用$kmp$优化转移, 复杂度是$O(26^2m^2n)$, 优化一下$kmp$的匹配的话可以达到$O(26m^2n)$

#include <iostream>
#include <sstream>
#include <algorithm>
#include <cstdio>
#include <math.h>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <string.h>
#include <bitset>
#define REP(i,a,n) for(int i=a;i<=n;++i)
#define PER(i,a,n) for(int i=n;i>=a;--i)
#define hr putchar(10)
#define pb push_back
#define lc (o<<1)
#define rc (lc|1)
#define mid ((l+r)>>1)
#define ls lc,l,mid
#define rs rc,mid+1,r
#define x first
#define y second
#define io std::ios::sync_with_stdio(false)
#define endl ‘\n‘
#define DB(a) ({REP(__i,1,n) cout<<a[__i]<<‘ ‘;hr;})
using namespace std;
typedef long long ll;
typedef pair<int,int> pii;
const int P = 1e9+7, INF = 0x3f3f3f3f;
ll gcd(ll a,ll b) {return b?gcd(b,a%b):a;}
ll qpow(ll a,ll n) {ll r=1%P;for (a%=P;n;a=a*a%P,n>>=1)if(n&1)r=r*a%P;return r;}
ll inv(ll x){return x<=1?1:inv(P%x)*(P-P/x)%P;}
inline int rd() {int x=0;char p=getchar();while(p<‘0‘||p>‘9‘)p=getchar();while(p>=‘0‘&&p<=‘9‘)x=x*10+p-‘0‘,p=getchar();return x;}
//head

const int N = 1310;
char s1[N], s2[55], s3[55];
int f2[55], f3[55];

void getFail(char *s, int *f) {
    int m = strlen(s);
    f[0]=f[1]=0;
    REP(i,1,m-1) {
        int j=f[i];
        while (j&&s[i]!=s[j]) j=f[j];
        if (s[i]==s[j]) ++j;
        f[i+1] = j;
    }
	REP(i,1,m-1) while (f[i]&&s[i]==s[f[i]]) f[i]=f[f[i]];
}

int dp[N][55][55];

int main() {
	scanf("%s%s%s", s1+1, s2, s3);
	getFail(s2,f2),getFail(s3,f3);
	int n1 = strlen(s1+1), n2 = strlen(s2), n3 = strlen(s3);
	memset(dp,0xcf,sizeof dp);
	int INF = dp[0][0][0], ans = INF;
	dp[0][0][0] = 0;
	REP(i,1,n1) REP(j,0,n2) REP(k,0,n3) if (dp[i-1][j][k]!=INF) {
		int L=‘a‘,R=‘z‘;
		if (s1[i]!=‘*‘) L=R=s1[i];
		REP(c,L,R) {
			int p2=j,p3=k;
			while (p2&&s2[p2]!=c) p2=f2[p2];
			if (s2[p2]==c) ++p2;
			while (p3&&s3[p3]!=c) p3=f3[p3];
			if (s3[p3]==c) ++p3;
			dp[i][p2][p3] = max(dp[i][p2][p3], dp[i-1][j][k]+(p2==n2)-(p3==n3));
			if (i==n1) ans = max(ans, dp[i][p2][p3]);
		}
	}
	printf("%d\n", ans);
}

对两个串建立$AC$自动机优化, 复杂度是$O(26mn)$.

#include <iostream>
#include <algorithm>
#include <cstdio>
#include <math.h>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <string.h>
#include <bitset>
#define REP(i,a,n) for(int i=a;i<=n;++i)
#define PER(i,a,n) for(int i=n;i>=a;--i)
#define hr putchar(10)
#define pb push_back
#define lc (o<<1)
#define rc (lc|1)
#define mid ((l+r)>>1)
#define ls lc,l,mid
#define rs rc,mid+1,r
#define x first
#define y second
#define io std::ios::sync_with_stdio(false)
#define endl ‘\n‘
using namespace std;
typedef long long ll;
typedef pair<int,int> pii;
const int P = 1e9+7, INF = 0x3f3f3f3f;
ll gcd(ll a,ll b) {return b?gcd(b,a%b):a;}
ll qpow(ll a,ll n) {ll r=1%P;for (a%=P;n;a=a*a%P,n>>=1)if(n&1)r=r*a%P;return r;}
ll inv(ll x){return x<=1?1:inv(P%x)*(P-P/x)%P;}
//head

const int N = 2e3+10;
int n, T, tot;
char s1[N], s2[N], s3[N];
int ch[N][26], ac[N][26];
int fail[N], sz[N], val[N], sum[N];
queue<int> q;

void build(int o) {
	REP(i,0,25) ac[o][i]=o;
	q.push(o), fail[o]=o;
	while (q.size()) {
		int x = q.front(); q.pop();
		sum[x] = sum[fail[x]]+val[x];
		REP(i,0,25) {
			if (ch[x][i]) {
				int y = ch[x][i];
				q.push(y);
				fail[y] = ac[fail[x]][i];
				ac[x][i] = y;
			} else ac[x][i] = ac[fail[x]][i];
		}
	}
}

void add(int &o, char *s, int v) {
	if (!o) o=++tot;
	if (*s) add(ch[o][*s-‘a‘],s+1,v);
	else val[o] += v;
}

int dp[N][N];

int main() {
	scanf("%s%s%s",s1+1,s2,s3);
	add(T,s2,1),add(T,s3,-1);
	build(T);
	int n = strlen(s1+1);
	memset(dp,0xef,sizeof dp);
	dp[0][1]=0;
	REP(i,1,n) {
		REP(j,1,tot) {
			int L=‘a‘,R=‘z‘;
			if (s1[i]!=‘*‘) L=R=s1[i];
			REP(c,L,R) {
				int x = ac[j][c-‘a‘];
				dp[i][x]=max(dp[i][x],dp[i-1][j]+sum[x]);
			}
		}
	}
	printf("%d\n", *max_element(dp[n]+1,dp[n]+tot));
}

原文地址:https://www.cnblogs.com/uid001/p/10846438.html

时间: 2024-10-15 08:21:38

cf 1163D Mysterious Code (字符串, dp)的相关文章

Codeforces 1150D(字符串dp)

反思 三维的dp压根没看出来,看题解以后思路又很直观,找几道字符串dp练练才行 序列自动机和优化一维略 /* __ __ * ____| |_____| |____ * | | * | __ | * | | * | > <. | * | | * | | * | ... ⌒ ... | * | | * | | * |___ __| * | | * | | Code is far away from bug with the animal protecting * | | 神兽保佑,代码无bug

POJ 1850 Code 数位DP

据说又是一道组合数学题,数学不好的我只想出的DP写法 注意如果输入不合法要输出0 #include <cstdio> #include <cstring> #include <cmath> #include <algorithm> #include <climits> #include <string> #include <iostream> #include <map> #include <cstdli

[DP总结]字符串DP

顾名又思义,是在字符串上进行的DP操作.因为字符串本身可以看作是一个序列,所以有些时候字符串DP可以用区间DP来解决. P2246 SAC#1 - Hello World(升级版) 题目描述 在讲义的某一面,他看见了一篇文章.这篇文章由英文字母(大小写均有).数字.和空白字符(制表/空格/回车)构成. pipapi想起了他最近刚刚学会写的Hello World程序.他非常好奇,这篇文章中,"HelloWorld"作为子序列到底出现过多少次呢? 由于papapi是个智障,大小写对于他而言

Educational CF # 17 C 二分,字符串 D 最长路,dp

Educational Codeforces Round 17 C. Two strings 题意:两个字符串A,B,从B中删除尽可能少的子串,要使得B剩下的字符串是A的子序列,输出B剩下的字符串.(注意子串与子序列区别) 总结:看了某神犇的代码,不太理解..官方题解:不要去想从B中删掉子串,应该想,从B的左端取出一段子串,再从右端取出一段子串. // Educational Codeforces Round 17 C #include<bits/stdc++.h> using namespa

HDU 5375——Gray code——————【dp||讨论】

Gray code Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 569    Accepted Submission(s): 337 Problem Description The reflected binary code, also known as Gray code after Frank Gray, is a binary

CF - 1111D Destroy the Colony DP

题目传送门 题意: 这个题目真的是最近遇到的最难读. 有一个长度n的字符串,每一位字符都代表的是该种种类的敌人. 现在如果一个序列合法的话,就是同一种种类的敌人都在字符串的左半边或者右半边. 现在有q次询问,现在问你将 s[x] 和 s[y] 的敌人都放在同一边的合法方案数是多少. 题解: 首先如果划分组之后,那么答案就是,m! * m! * 2/ (c1! * c2! * c3! .... ) 然后对于每一组来说就是 这个值是一定的. 然后就是需要求这个分组方案数. 对于分组方案数,可以通过背

fzu2172 字符串dp

F - 巡了南山我巡北山 Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice FZU 2172 Description 大师兄在取经途中迷上了ACM-ICPC,稍不留神,师傅就被妖怪抓走了. 大师兄并不着急去救师傅,在虐这道简单题: 有两个字符串A和B,每一次可以选择以下操作中的一种,只对字符串A进行操作,用最少的操作使得字符串A与字符串B相等: 在

hdu 5375 Gray code(DP)

hdu 5375 Gray code Problem Description The reflected binary code, also known as Gray code after Frank Gray, is a binary numeral system where two successive values differ in only onebit (binary digit). The reflected binary code was originally designed

UVALive 6514:Crusher’s Code(概率dp)

题目链接 https://icpcarchive.ecs.baylor.edu/external/65/6514.pdf 题意:给出n个数(n<8) 求这n个数分别两个程序排成有序时,程序的期望迭代次数.排序程序如下. // Monty's Code while (!sorted(a)) { int i = random(n) ; int j = random(n) ; if (a[min(i,j)] > a[max(i,j)]) swap(a[i], a[j]) ; } //Carlos's